Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.net
Interface SocketOptions

All Known Implementing Classes:
  DatagramSocketImpl, SocketImpl

public interface SocketOptions

Interface of methods to get/set socket options. This interface is implemented by: SocketImpl and DatagramSocketImpl. Subclasses of these should override the methods of this interface in order to support their own options.

The methods and constants which specify options in this interface are for implementation only. If you're not subclassing SocketImpl or DatagramSocketImpl, you won't use these directly. There are type-safe methods to get/set each of these options in Socket, ServerSocket, DatagramSocket and MulticastSocket.

A subset of the standard BSD-style socket options are supported in the base classes, PlainSocketImpl and PlainDatagramSocketImpl. A brief description of each and their use is provided.

Field Summary
`static int` | `IP_MULTICAST_IF` Set which outgoing interface on which to send multicast packets.
`static int` | `SO_BINDADDR` Fetch the local address binding of a socket (this option cannot be "set" only "gotten", since sockets are bound at creation time, and so the locally bound address cannot be changed).
`static int` | `SO_KEEPALIVE` When the keepalive option is set for a TCP socket and no data has been exchanged across the socket in either direction for 2 hours (NOTE: the actual value is implementation dependent), TCP automatically sends a keepalive probe to the peer.
`static int` | `SO_LINGER` Specify a linger-on-close timeout.
`static int` | `SO_RCVBUF` Set a hint the size of the underlying buffers used by the platform for incoming network I/O.
`static int` | `SO_REUSEADDR` Sets SO_REUSEADDR for a socket.
`static int` | `SO_SNDBUF` Set a hint the size of the underlying buffers used by the platform for outgoing network I/O.
`static int` | `SO_TIMEOUT` Set a timeout on blocking Socket operations:
`static int` | `TCP_NODELAY` Disable Nagle's algorithm for this connection.

Method Summary
`Object` | `getOption(int optID)` Fetch the value of an option.
`void` | `setOption(int optID, Object value)` Enable/disable the option specified by optID.

Field Detail

### TCP_NODELAY

    public static final int TCP_NODELAY

  Disable Nagle's algorithm for this connection. Written data to the network is not buffered pending acknowledgement of previously written data.

  Valid for TCP only: SocketImpl.

  See Also:
    `Socket.setTcpNoDelay(boolean)`, `Socket.getTcpNoDelay()`

### SO_BINDADDR

    public static final int SO_BINDADDR

  Fetch the local address binding of a socket (this option cannot be "set" only "gotten", since sockets are bound at creation time, and so the locally bound address cannot be changed). The default local address of a socket is INADDR_ANY, meaning any local address on a multi-homed host. A multi-homed host can use this option to accept connections to only one of its addresses (in the case of a ServerSocket or DatagramSocket), or to specify its return address to the peer (for a Socket or DatagramSocket). The parameter of this option is an InetAddress.

  This option must be specified in the constructor.

  Valid for: SocketImpl, DatagramSocketImpl

  See Also:
    `Socket.getLocalAddress()`, `DatagramSocket.getLocalAddress()`

### SO_REUSEADDR

    public static final int SO_REUSEADDR

  Sets SO_REUSEADDR for a socket. This is used only for MulticastSockets in java, and it is set by default for MulticastSockets.

  Valid for: DatagramSocketImpl

### IP_MULTICAST_IF

    public static final int IP_MULTICAST_IF

  Set which outgoing interface on which to send multicast packets. Useful on hosts with multiple network interfaces, where applications want to use other than the system default. Takes/returns an InetAddress.

  Valid for Multicast: DatagramSocketImpl

  See Also:
    `MulticastSocket.setInterface(java.net.InetAddress)`, `MulitcastSocket#getInterface`

### SO_LINGER

    public static final int SO_LINGER

  Specify a linger-on-close timeout. This option disables/enables immediate return from a close() of a TCP Socket. Enabling this option with a non-zero Integer timeout means that a close() will block pending the transmission and acknowledgement of all data written to the peer, at which point the socket is closed gracefully. Upon reaching the linger timeout, the socket is closed forcefully, with a TCP RST. Enabling the option with a timeout of zero does a forceful close immediately. If the specified timeout value exceeds 65,535 it will be reduced to 65,535.

  Valid only for TCP: SocketImpl

  See Also:
    `Socket.setSoLinger(boolean, int)`, `Socket.getSoLinger()`

### SO_TIMEOUT

    public static final int SO_TIMEOUT

  Set a timeout on blocking Socket operations:

       ServerSocket.accept();
       SocketInputStream.read();
       DatagramSocket.receive();

  The option must be set prior to entering a blocking operation to take effect. If the timeout expires and the operation would continue to block, java.io.InterruptedIOException is raised. The Socket is not closed in this case.

  Valid for all sockets: SocketImpl, DatagramSocketImpl

  See Also:
    `Socket.setSoTimeout(int)`, `ServerSocket.setSoTimeout(int)`, `DatagramSocket.setSoTimeout(int)`

### SO_SNDBUF

    public static final int SO_SNDBUF

  Set a hint the size of the underlying buffers used by the platform for outgoing network I/O. When used in set, this is a suggestion to the kernel from the application about the size of buffers to use for the data to be sent over the socket. When used in get, this must return the size of the buffer actually used by the platform when sending out data on this socket. Valid for all sockets: SocketImpl, DatagramSocketImpl
  See Also:
    `Socket.setSendBufferSize(int)`, `Socket.getSendBufferSize()`, `DatagramSocket.setSendBufferSize(int)`, `DatagramSocket.getSendBufferSize()`

### SO_RCVBUF

    public static final int SO_RCVBUF

  Set a hint the size of the underlying buffers used by the platform for incoming network I/O. When used in set, this is a suggestion to the kernel from the application about the size of buffers to use for the data to be received over the socket. When used in get, this must return the size of the buffer actually used by the platform when receiving in data on this socket. Valid for all sockets: SocketImpl, DatagramSocketImpl
  See Also:
    `Socket.setReceiveBufferSize(int)`, `Socket.getReceiveBufferSize()`, `DatagramSocket.setReceiveBufferSize(int)`, `DatagramSocket.getReceiveBufferSize()`

### SO_KEEPALIVE

    public static final int SO_KEEPALIVE

  When the keepalive option is set for a TCP socket and no data has been exchanged across the socket in either direction for 2 hours (NOTE: the actual value is implementation dependent), TCP automatically sends a keepalive probe to the peer. This probe is a TCP segment to which the peer must respond. One of three responses is expected: 1. The peer responds with the expected ACK. The application is not notified (since everything is OK). TCP will send another probe following another 2 hours of inactivity. 2. The peer responds with an RST, which tells the local TCP that the peer host has crashed and rebooted. The socket is closed. 3. There is no response from the peer. The socket is closed. The purpose of this option is to detect if the peer host crashes. Valid only for TCP socket: SocketImpl
  See Also:
    `Socket.setKeepAlive(boolean)`, `Socket.getKeepAlive()`

Method Detail

### setOption

    public void setOption(int optID,
                          Object value)
                   throws SocketException

  Enable/disable the option specified by optID. If the option is to be enabled, and it takes an option-specific "value", this is passed in value. The actual type of value is option-specific, and it is an error to pass something that isn't of the expected type:

       SocketImpl s;
       ...
       s.setOption(SO_LINGER, new Integer(10));
          // OK - set SO_LINGER w/ timeout of 10 sec.
       s.setOption(SO_LINGER, new Double(10));
          // ERROR - expects java.lang.Integer

  If the requested option is binary, it can be set using this method by a java.lang.Boolean:

       s.setOption(TCP_NODELAY, new Boolean(true));
          // OK - enables TCP_NODELAY, a binary option

  Any option can be disabled using this method with a Boolean(false):

       s.setOption(TCP_NODELAY, new Boolean(false));
          // OK - disables TCP_NODELAY
       s.setOption(SO_LINGER, new Boolean(false));
          // OK - disables SO_LINGER

  For an option that has a notion of on and off, and requires a non-boolean parameter, setting its value to anything other than Boolean(false) implicitly enables it.
  Throws SocketException if the option is unrecognized, the socket is closed, or some low-level error occurred
  Parameters:
    `optID` - identifies the option
    `value` - the parameter of the socket option
  Throws:
    `SocketException` - if the option is unrecognized, the socket is closed, or some low-level error occurred
  See Also:
    `getOption(int)`

### getOption

    public Object getOption(int optID)
                     throws SocketException

  Fetch the value of an option. Binary options will return java.lang.Boolean(true) if enabled, java.lang.Boolean(false) if disabled, e.g.:

       SocketImpl s;
       ...
       Boolean noDelay = (Boolean)(s.getOption(TCP_NODELAY));
       if (noDelay.booleanValue()) {
           // true if TCP_NODELAY is enabled...
       ...
       }

  For options that take a particular type as a parameter, getOption(int) will return the paramter's value, else it will return java.lang.Boolean(false):

       Object o = s.getOption(SO_LINGER);
       if (o instanceof Integer) {
           System.out.print("Linger time is " + ((Integer)o).intValue());
       } else {
         // the true type of o is java.lang.Boolean(false);
       }

  Parameters:
    `optID` - an `int` identifying the option to fetch
  Returns:
    the value of the option
  Throws:
    `SocketException` - if the socket is closed
    `SocketException` - if optID is unknown along the protocol stack (including the SocketImpl)
  See Also:
    `setOption(int, java.lang.Object)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.